/*================================================================================================*
 * Глобальные определения и интерфейс к аппаратуре
 *================================================================================================*/

#ifndef GLOBAL_H_
#define GLOBAL_H_

#include <stddef.h>
#include <stdint.h>
#include <sys/types.h> /* ssize_t */
#include "chip.h"

/*================================================================================================*/
#define ASSERT(condition)   switch (0){ case 0: case (condition):; }

/* Вычисление количества элементов массива */
#define ARRLEN(array)       (sizeof(array) / sizeof((array)[0]))

/* Выравнивание вниз (усечение n до кратного m) */
#define ALIGN_DOWN(n, m)    ((n) - ((n) % (m)))
/* Выравнивание вверх (дополнение n до кратного m) */
#define ALIGN_UP(n, m)      ALIGN_DOWN((n) + (m) - 1, (m))

/* Макро для склеивания строк на уровне препроцессора */
#ifndef CONCAT
#define CONCAT_(a, b)       a ## b
#define CONCAT(a,b)         CONCAT_(a, b)
#endif

/* Преобразование аргумента в строку */
#define STRINGIZE_(str)     #str
#define STRINGIZE(str)      STRINGIZE_(str)
/*================================================================================================*/

/*================================================================================================*/
/* Расчет количества тактов на заданное время, с округлением вверх, вниз, на ближайшее */
#define CYCLES_NS_ROUND(clk, ns)    (((ns) * 1ULL * (clk) + 500000000) / 1000000000)
#define CYCLES_NS_NLESS(clk, ns)    (((ns) * 1ULL * (clk) + 999999999) / 1000000000)
#define CYCLES_NS_NMORE(clk, ns)    (((ns) * 1ULL * (clk)) / 1000000000)
/*================================================================================================*/

/*================================================================================================*/
/* Арифметика на препроцессоре */
/* floor(log2(uint32_t x)) */
#define FLOOR_LOG2(x) \
    (((x) > 1) + ((x) > 3) + ((x) > 7) + ((x) > 0x0F) + ((x) > 0x1F) + ((x) > 0x3F) + ((x) > 0x7F) + \
    ((x) > 0xFF) + ((x) > 0x1FF) + ((x) > 0x3FF) + ((x) > 0x7FF) + ((x) > 0xFFF) + ((x) > 0x1FFF) + \
    ((x) > 0x3FFF) + ((x) > 0x7FFF) + ((x) > 0xFFFF) + ((x) > 0x1FFFF) + ((x) > 0x3FFFF) + \
    ((x) > 0x7FFFF) + ((x) > 0xFFFFF) + ((x) > 0x1FFFFF) + ((x) > 0x3FFFFF) + ((x) > 0x7FFFFF) + \
    ((x) > 0xFFFFFF) + ((x) > 0x1FFFFFF) + ((x) > 0x3FFFFFF) + ((x) > 0x7FFFFFF) + \
    ((x) > 0xFFFFFFF) + ((x) > 0x1FFFFFFF) + ((x) > 0x3FFFFFFF) + ((x) > 0x7FFFFFFF))

/* ceil(log2(uint32_t x)) */
#define CEIL_LOG2(x) \
    (((x) > 1) + ((x) > 2) + ((x) > 4) + ((x) > 8) + ((x) > 0x10) + ((x) > 0x20) + ((x) > 0x40) + \
    ((x) > 0x80) + ((x) > 0x100) + ((x) > 0x200) + ((x) > 0x400) + ((x) > 0x800) + ((x) > 0x1000) + \
    ((x) > 0x2000) + ((x) > 0x4000) + ((x) > 0x8000) + ((x) > 0x10000) + ((x) > 0x20000) + \
    ((x) > 0x40000) + ((x) > 0x80000) + ((x) > 0x100000) + ((x) > 0x200000) + ((x) > 0x400000) + \
    ((x) > 0x800000) + ((x) > 0x1000000) + ((x) > 0x2000000) + ((x) > 0x4000000) + \
    ((x) > 0x8000000) + ((x) > 0x10000000) + ((x) > 0x20000000) + ((x) > 0x40000000) + \
    ((x) > 0x80000000))

/* Ближайшая степень двойки */
#define CLOSEST_POW2(x) \
    ((1UL << FLOOR_LOG2(x)) * (1 + (x > (1UL << FLOOR_LOG2(x)) + (1UL << FLOOR_LOG2(x)) / 2)))

/* Количество бит "1" в 32-битной константе */
#define N_SET_BITS(x)  ( \
    ((x >> 0) & 1) + ((x >> 1) & 1) + ((x >> 2) & 1) + ((x >> 3) & 1) + \
    ((x >> 4) & 1) + ((x >> 5) & 1) + ((x >> 6) & 1) + ((x >> 7) & 1) + \
    ((x >> 8) & 1) + ((x >> 9) & 1) + ((x >> 10) & 1) + ((x >> 11) & 1) + \
    ((x >> 12) & 1) + ((x >> 13) & 1) + ((x >> 14) & 1) + ((x >> 15) & 1) + \
    ((x >> 16) & 1) + ((x >> 17) & 1) + ((x >> 18) & 1) + ((x >> 19) & 1) + \
    ((x >> 20) & 1) + ((x >> 21) & 1) + ((x >> 22) & 1) + ((x >> 23) & 1) + \
    ((x >> 24) & 1) + ((x >> 25) & 1) + ((x >> 26) & 1) + ((x >> 27) & 1) + \
    ((x >> 28) & 1) + ((x >> 29) & 1) + ((x >> 30) & 1) + ((x >> 31) & 1))
/*================================================================================================*/

#endif /* GLOBAL_H_ */
